Overview | Package | Class | Use | Tree | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.index
Class AtomicReader

    java.lang.Object
      org.apache.lucene.index.IndexReader
          org.apache.lucene.index.AtomicReader

All Implemented Interfaces:
  Closeable

Direct Known Subclasses:
  FilterAtomicReader, ParallelAtomicReader, SegmentReader, SlowCompositeReaderWrapper

    public abstract class AtomicReader

extends IndexReader

`AtomicReader` is an abstract class, providing an interface for accessing an index. Search of an index is done entirely through this abstract interface, so that any subclass which implements it is searchable. IndexReaders implemented by this subclass do not consist of several sub-readers, they are atomic. They support retrieval of stored fields, doc values, terms, and postings.

For efficiency, in this API documents are often referred to via document numbers, non-negative integers which each name a unique document in the index. These document numbers are ephemeral -- they may change as documents are added to and deleted from an index. Clients should thus not rely on a given document having the same number between sessions.

NOTE: `IndexReader` instances are completely thread safe, meaning multiple threads can call any of its methods, concurrently. If your application requires external synchronization, you should not synchronize on the `IndexReader` instance; use your own (non-Lucene) objects instead.

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader
`IndexReader.ReaderClosedListener`

Constructor Summary
`protected` | `AtomicReader()` Sole constructor.

Method Summary
`int` | `docFreq(Term term)` Returns the number of documents containing the `term`.
`abstract Fields` | `fields()` Returns `Fields` for this reader.
`abstract BinaryDocValues` | `getBinaryDocValues(String field)` Returns `BinaryDocValues` for this field, or null if no `BinaryDocValues` were indexed for this field.
`AtomicReaderContext` | `getContext()` Expert: Returns the root `IndexReaderContext` for this `IndexReader`'s sub-reader tree.
`int` | `getDocCount(String field)` Returns the number of documents that have at least one term for this field, or -1 if this measure isn't stored by the codec.
`abstract FieldInfos` | `getFieldInfos()` Get the `FieldInfos` describing all fields in this reader.
`abstract Bits` | `getLiveDocs()` Returns the `Bits` representing live (not deleted) docs.
`abstract NumericDocValues` | `getNormValues(String field)` Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed.
`abstract NumericDocValues` | `getNumericDocValues(String field)` Returns `NumericDocValues` for this field, or null if no `NumericDocValues` were indexed for this field.
`abstract SortedDocValues` | `getSortedDocValues(String field)` Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field.
`abstract SortedSetDocValues` | `getSortedSetDocValues(String field)` Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field.
`long` | `getSumDocFreq(String field)` Returns the sum of `TermsEnum.docFreq()` for all terms in this field, or -1 if this measure isn't stored by the codec.
`long` | `getSumTotalTermFreq(String field)` Returns the sum of `TermsEnum.totalTermFreq()` for all terms in this field, or -1 if this measure isn't stored by the codec (or if this fields omits term freq and positions).
`boolean` | `hasNorms(String field)` Deprecated. (4.0) use `getFieldInfos()` and check `FieldInfo.hasNorms()` for the field instead.
`DocsEnum` | `termDocsEnum(Term term)` Returns `DocsEnum` for the specified term.
`DocsAndPositionsEnum` | `termPositionsEnum(Term term)` Returns `DocsAndPositionsEnum` for the specified term.
`Terms` | `terms(String field)` This may return null if the field does not exist.
`long` | `totalTermFreq(Term term)` Returns the number of documents containing the term `t`.

Methods inherited from class org.apache.lucene.index.IndexReader
`addReaderClosedListener, close, decRef, doClose, document, document, document, ensureOpen, equals, getCombinedCoreAndDeletesKey, getCoreCacheKey, getRefCount, getTermVector, getTermVectors, hasDeletions, hashCode, incRef, leaves, maxDoc, numDeletedDocs, numDocs, open, open, open, open, open, registerParentReader, removeReaderClosedListener, tryIncRef`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AtomicReader

    protected AtomicReader()

  Sole constructor. (For invocation by subclass constructors, typically implicit.)

Method Detail

### getContext

    public final AtomicReaderContext getContext()

  Description copied from class: `IndexReader`
  Expert: Returns the root `IndexReaderContext` for this `IndexReader`'s sub-reader tree.

  Iff this reader is composed of sub readers, i.e. this reader being a composite reader, this method returns a `CompositeReaderContext` holding the reader's direct children as well as a view of the reader tree's atomic leaf contexts. All sub- `IndexReaderContext` instances referenced from this readers top-level context are private to this reader and are not shared with another context tree. For example, IndexSearcher uses this API to drive searching by one atomic leaf reader at a time. If this reader is not composed of child readers, this method returns an `AtomicReaderContext`.

  Note: Any of the sub-`CompositeReaderContext` instances referenced from this top-level context do not support `CompositeReaderContext.leaves()`. Only the top-level context maintains the convenience leaf-view for performance reasons.

  Specified by:
    `getContext` in class `IndexReader`

### hasNorms

    @Deprecated
    public final boolean hasNorms(String field)
                           throws IOException

  Deprecated. (4.0) use `getFieldInfos()` and check `FieldInfo.hasNorms()` for the field instead.

  Returns true if there are norms stored for this field.

  Throws:
    `IOException`

### fields

    public abstract Fields fields()
                           throws IOException

  Returns `Fields` for this reader. This method may return null if the reader has no postings.

  Throws:
    `IOException`

### docFreq

    public final int docFreq(Term term)
                      throws IOException

  Description copied from class: `IndexReader`
  Returns the number of documents containing the `term`. This method returns 0 if the term or field does not exists. This method does not take into account deleted documents that have not yet been merged away.

  Specified by:
    `docFreq` in class `IndexReader`
  Throws:
    `IOException`
  See Also:
    `TermsEnum.docFreq()`

### totalTermFreq

    public final long totalTermFreq(Term term)
                             throws IOException

  Returns the number of documents containing the term `t`. This method returns 0 if the term or field does not exists. This method does not take into account deleted documents that have not yet been merged away.

  Specified by:
    `totalTermFreq` in class `IndexReader`
  Throws:
    `IOException`
  See Also:
    `TermsEnum.totalTermFreq()`

### getSumDocFreq

    public final long getSumDocFreq(String field)
                             throws IOException

  Description copied from class: `IndexReader`
  Returns the sum of `TermsEnum.docFreq()` for all terms in this field, or -1 if this measure isn't stored by the codec. Note that, just like other term measures, this measure does not take deleted documents into account.

  Specified by:
    `getSumDocFreq` in class `IndexReader`
  Throws:
    `IOException`
  See Also:
    `Terms.getSumDocFreq()`

### getDocCount

    public final int getDocCount(String field)
                          throws IOException

  Description copied from class: `IndexReader`
  Returns the number of documents that have at least one term for this field, or -1 if this measure isn't stored by the codec. Note that, just like other term measures, this measure does not take deleted documents into account.

  Specified by:
    `getDocCount` in class `IndexReader`
  Throws:
    `IOException`
  See Also:
    `Terms.getDocCount()`

### getSumTotalTermFreq

    public final long getSumTotalTermFreq(String field)
                                   throws IOException

  Description copied from class: `IndexReader`
  Returns the sum of `TermsEnum.totalTermFreq()` for all terms in this field, or -1 if this measure isn't stored by the codec (or if this fields omits term freq and positions). Note that, just like other term measures, this measure does not take deleted documents into account.

  Specified by:
    `getSumTotalTermFreq` in class `IndexReader`
  Throws:
    `IOException`
  See Also:
    `Terms.getSumTotalTermFreq()`

### terms

    public final Terms terms(String field)
                      throws IOException

  This may return null if the field does not exist.

  Throws:
    `IOException`

### termDocsEnum

    public final DocsEnum termDocsEnum(Term term)
                                throws IOException

  Returns `DocsEnum` for the specified term. This will return null if either the field or term does not exist.

  Throws:
    `IOException`
  See Also:
    `TermsEnum.docs(Bits, DocsEnum)`

### termPositionsEnum

    public final DocsAndPositionsEnum termPositionsEnum(Term term)
                                                 throws IOException

  Returns `DocsAndPositionsEnum` for the specified term. This will return null if the field or term does not exist or positions weren't indexed.

  Throws:
    `IOException`
  See Also:
    `TermsEnum.docsAndPositions(Bits, DocsAndPositionsEnum)`

### getNumericDocValues

    public abstract NumericDocValues getNumericDocValues(String field)
                                                  throws IOException

  Returns `NumericDocValues` for this field, or null if no `NumericDocValues` were indexed for this field. The returned instance should only be used by a single thread.

  Throws:
    `IOException`

### getBinaryDocValues

    public abstract BinaryDocValues getBinaryDocValues(String field)
                                                throws IOException

  Returns `BinaryDocValues` for this field, or null if no `BinaryDocValues` were indexed for this field. The returned instance should only be used by a single thread.

  Throws:
    `IOException`

### getSortedDocValues

    public abstract SortedDocValues getSortedDocValues(String field)
                                                throws IOException

  Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field. The returned instance should only be used by a single thread.

  Throws:
    `IOException`

### getSortedSetDocValues

    public abstract SortedSetDocValues getSortedSetDocValues(String field)
                                                      throws IOException

  Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field. The returned instance should only be used by a single thread.

  Throws:
    `IOException`

### getNormValues

    public abstract NumericDocValues getNormValues(String field)
                                            throws IOException

  Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed. The returned instance should only be used by a single thread.

  Throws:
    `IOException`

### getFieldInfos

    public abstract FieldInfos getFieldInfos()

  Get the `FieldInfos` describing all fields in this reader.

  WARNING: This API is experimental and might change in incompatible ways in the next release.

### getLiveDocs

    public abstract Bits getLiveDocs()

  Returns the `Bits` representing live (not deleted) docs. A set bit indicates the doc ID has not been deleted. If this method returns null it means there are no deleted documents (all documents are live). The returned instance has been safely published for use by multiple threads without additional synchronization.

Overview | Package | Class | Use | Tree | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.